// based on Microsoft's CPngImage, this implementation removes a memory leak that is present in CPngImage::LoadFromBuffer()
// C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\atlmfc\include\afxtoolbarimages.h
//
// If the load functions had been declared virtual I could have derived from CPngImage and overridden one function, but no...
// I've removed the MFC toolbars related code as that requires a C++ friendship this class can never have

#include "stdafx.h"
#include <afxtoolbarimages.h>
#include "svlPngImage.h"

#ifndef AFX_PNG_RESOURCE_TYPE
#define AFX_PNG_RESOURCE_TYPE	_T("PNG")
#endif	//AFX_PNG_RESOURCE_TYPE
//////////////////////////////////////////////////////////////////////
// svlPngImage

CImage* svlPngImage::m_pImage;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

svlPngImage::svlPngImage()
{
}

svlPngImage::~svlPngImage()
{
}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

BOOL svlPngImage::Load(UINT uiResID, HINSTANCE hinstRes)
{
	return Load(MAKEINTRESOURCE(uiResID), hinstRes);
}

BOOL svlPngImage::Load(LPCTSTR lpszResourceName, HINSTANCE hinstRes)
{
	if (hinstRes == NULL)
	{
		hinstRes = AfxFindResourceHandle(lpszResourceName, AFX_PNG_RESOURCE_TYPE);
	}

	HRSRC hRsrc = ::FindResource(hinstRes, lpszResourceName, AFX_PNG_RESOURCE_TYPE);
	if (hRsrc == NULL)
	{
		return FALSE;
	}

	HGLOBAL hGlobal = LoadResource(hinstRes, hRsrc);
	if (hGlobal == NULL)
	{
		return FALSE;
	}

	LPVOID lpBuffer = ::LockResource(hGlobal);
	if (lpBuffer == NULL)
	{
		FreeResource(hGlobal);
		return FALSE;
	}

	BOOL bRes = LoadFromBuffer((LPBYTE) lpBuffer, (UINT) ::SizeofResource(hinstRes, hRsrc));

	UnlockResource(hGlobal);
	FreeResource(hGlobal);

	return bRes;
}
//*******************************************************************************
BOOL svlPngImage::LoadFromFile(LPCTSTR lpszPath)
{
	/*
	if (CMFCToolBarImages::m_bMultiThreaded)
	{
		CMFCToolBarImages::m_CriticalSection.Lock();
	}
	*/
	BOOL bRes = FALSE;

	if (m_pImage == NULL)
	{
		m_pImage = new CImage;
		ENSURE(m_pImage != NULL);
	}

	if (m_pImage->Load(lpszPath) == S_OK)
	{
		bRes = Attach(m_pImage->Detach());
	}
	/*
	if (CMFCToolBarImages::m_bMultiThreaded)
	{
		CMFCToolBarImages::m_CriticalSection.Unlock();
	}
	*/
	return bRes;
}
//*******************************************************************************
BOOL svlPngImage::LoadFromBuffer(LPBYTE lpBuffer, UINT uiSize)
{
	ASSERT(lpBuffer != NULL);

	HGLOBAL hRes = ::GlobalAlloc(GMEM_MOVEABLE, uiSize);
	if (hRes == NULL)
	{
		return FALSE;
	}

	IStream* pStream = NULL;
	LPVOID lpResBuffer = ::GlobalLock(hRes);
	ASSERT (lpResBuffer != NULL);

	memcpy(lpResBuffer, lpBuffer, uiSize);

	HRESULT hResult = ::CreateStreamOnHGlobal(hRes, FALSE, &pStream);

	if (hResult != S_OK)
	{
		return FALSE;
	}
	/*
	if (CMFCToolBarImages::m_bMultiThreaded)
	{
		CMFCToolBarImages::m_CriticalSection.Lock();
	}
	*/
	if (m_pImage == NULL)
	{
		m_pImage = new CImage;
		ENSURE(m_pImage != NULL);
	}

	m_pImage->Load(pStream);
	pStream->Release();

	BOOL bRes = Attach(m_pImage->Detach());

	/*
	if (CMFCToolBarImages::m_bMultiThreaded)
	{
		CMFCToolBarImages::m_CriticalSection.Unlock();
	}
	*/

	::GlobalUnlock(hRes);		// code that Microsoft forget, this fixes the leak
	::GlobalFree(hRes);			// code that Microsoft forget, this fixes the leak

	return bRes;
}

void __stdcall svlPngImage::CleanUp()
{
	if (m_pImage != NULL)
	{
		delete m_pImage;
		m_pImage = NULL;
	}
}
