#ifndef _SVL_PNG_IMAGE_H
#define _SVL_PNG_IMAGE_H

#include <atlimage.h>

// based on Microsoft's CPngImage, this implementation removes a memory leak that is present in CPngImage::LoadFromBuffer()
// C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\atlmfc\include\afxtoolbarimages.h
//
// If the load functions had been declared virtual I could have derived from CPngImage and overridden one function, but no...
// I've removed the MFC toolbars related code as that requires a C++ friendship this class can never have

class svlPngImage : public CBitmap  
{
// Construction/Destruction
public:
	svlPngImage();
	virtual ~svlPngImage();

// Attributes:
protected:
	static ATL::CImage* m_pImage;

// Operations:
public:
	BOOL Load (UINT uiResID, HINSTANCE hinstRes = NULL);
	BOOL Load (LPCTSTR lpszResourceName, HINSTANCE hinstRes = NULL);

	BOOL LoadFromFile (LPCTSTR lpszPath);
	BOOL LoadFromBuffer (LPBYTE lpBuffer, UINT uiSize);

	static void __stdcall CleanUp();
};

#endif	//_SVL_PNG_IMAGE_H
