
// testCPngImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testCPngImage.h"
#include "testCPngImageDlg.h"
#include "afxdialogex.h"

#include "..\..\..\svlCommonUI\svlPngImage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CtestCPngImageDlg dialog




CtestCPngImageDlg::CtestCPngImageDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CtestCPngImageDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	success = 0;
	fail = 0;
}

CtestCPngImageDlg::~CtestCPngImageDlg()
{
	svlPngImage::CleanUp();
	m_hIcon = NULL;
}

void CtestCPngImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CtestCPngImageDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_TEST_BMP, &CtestCPngImageDlg::OnBnClickedButtonTestBmp)
	ON_BN_CLICKED(IDC_BUTTON_TEST_PNG, &CtestCPngImageDlg::OnBnClickedButtonTestPng)
	ON_BN_CLICKED(IDC_BUTTON_TEST_PNG_ONLY, &CtestCPngImageDlg::OnBnClickedButtonTestPngOnly)
	ON_BN_CLICKED(IDC_BUTTON_TEST_SVL_PNG, &CtestCPngImageDlg::OnBnClickedButtonTestSVLPng)
END_MESSAGE_MAP()


// CtestCPngImageDlg message handlers

BOOL CtestCPngImageDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CComboBox	*combo = (CComboBox *)GetDlgItem(IDC_COMBO_COUNT);
	int			ix;

	ix = combo->AddString(_T("1"));
	combo->SetItemData(ix, 1);
	ix = combo->AddString(_T("100"));
	combo->SetItemData(ix, 100);
	ix = combo->AddString(_T("1000"));
	combo->SetItemData(ix, 1000);
	ix = combo->AddString(_T("10000"));
	combo->SetItemData(ix, 10000);
	ix = combo->AddString(_T("65536"));
	combo->SetItemData(ix, 65536);
	ix = combo->AddString(_T("100000"));
	combo->SetItemData(ix, 100000);
	
	combo->SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CtestCPngImageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CtestCPngImageDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CtestCPngImageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CtestCPngImageDlg::OnOK()
{
	CDialogEx::OnOK();
}


void CtestCPngImageDlg::OnCancel()
{
	CDialogEx::OnCancel();
}

// helper methods

void CtestCPngImageDlg::setStatus(UINT			id,
								  const TCHAR	*message)
{
	CWnd	*wnd;

	wnd = GetDlgItem(id);
	if (wnd != NULL)
	{
		wnd->SetWindowText(message);
	}
}

DWORD CtestCPngImageDlg::getCount()
{
	DWORD		value = 1;	// allocate at least once
	CComboBox	*combo = (CComboBox *)GetDlgItem(IDC_COMBO_COUNT);
	int			ix;

	ix = combo->GetCurSel();
	if (ix != -1)
		value = combo->GetItemData(ix);

	return value;
}

void CtestCPngImageDlg::setInfo(const TCHAR	*fragment,
								int			startOrFinish)
{
	DWORD	n;
	CString	str;

	n = getCount();
	if (startOrFinish)
	{
		str.Format(_T("Running %u tests of %s..."), n, fragment);
	}
	else
	{
		str.Format(_T("Completed %u tests of %s"), n, fragment);
	}

	setStatus(IDC_STATIC_INFO, str);
}

void CtestCPngImageDlg::handleSuccessFailure(int			ok, 
											 UINT			id,
											 const TCHAR	*str)
{
	CString	m;

	if (!ok)
	{
		fail++;
		m.Format(_T("%s load fail %d (success %d)"), str, fail, success);
		setStatus(id, m);
	}
	else
	{
		success++;
		m.Format(_T("%s load success %d"), str, success);
		setStatus(id, m);
	}

	if (fail > 0)
		setStatus(IDC_STATIC_INFO_FAIL, _T("No more HGLOBALs can be allocated!"));
	else
		setStatus(IDC_STATIC_INFO_FAIL, _T(""));
}

// test loading a .bmp into a CBitmap multiple times
// this will not leak

void CtestCPngImageDlg::OnBnClickedButtonTestBmp()
{
	DWORD	i, n;
	
	success = 0;
	fail = 0;

	setInfo(_T("CBitmap"), TRUE);

	n = getCount();
	for(i = 0; i < n; i++)
	{
		UINT	id = IDB_BITMAP_BMP;
		CBitmap	bitmapBMP;
		int		ok;
	
		ok = bitmapBMP.LoadMappedBitmap(id);
		handleSuccessFailure(ok, IDC_STATIC_STATUS_BMP, _T("BMP"));
	}

	setInfo(_T("CBitmap"), FALSE);
}

// test loading a .png into a CBitmap and if that fails, use a CPngImage to load the image then attach that to a CBitmap
// why do this? It allows you to just specify a resource id without knowing/caring if it's BMP or PNG, but get a loaded image.
//
// this will not leak the image, but it will leak the hGlobal memory used to allocate the PNG during the load, leak found by Memory Validator

void CtestCPngImageDlg::OnBnClickedButtonTestPng()
{
	DWORD	i, n;
	
	success = 0;
	fail = 0;

	setInfo(_T("CPngImage via CBitmap"), TRUE);

	n = getCount();
	for(i = 0; i < n; i++)
	{
		UINT	id = IDB_BITMAP_PNG;
		CBitmap	bitmapPNG;
		int		ok;

		ok = bitmapPNG.LoadMappedBitmap(id);
		if (!ok)
		{
			CPngImage image;
	
			ok = image.Load(id, AfxGetInstanceHandle());
			handleSuccessFailure(ok, IDC_STATIC_STATUS_BMP_PNG, _T("PNG"));
			if (ok)
			{
				bitmapPNG.Attach(image.Detach());	
			}
		}
	}

	setInfo(_T("CPngImage via CBitmap"), FALSE);
}

// test loading a .png into a CPngImage multiple times
// this will not leak the image, but it will leak the hGlobal memory used to allocate the PNG during the load, leak found by Memory Validator

void CtestCPngImageDlg::OnBnClickedButtonTestPngOnly()
{
	DWORD	i, n;
	
	success = 0;
	fail = 0;

	setInfo(_T("CPngImage"), TRUE);

	n = getCount();
	for(i = 0; i < n; i++)
	{
		UINT		id = IDB_BITMAP_PNG;
		CPngImage	image;
		int			ok;

		ok = image.Load(id, AfxGetInstanceHandle());
		handleSuccessFailure(ok, IDC_STATIC_STATUS_PNG_ONLY, _T("PNG"));
	}

	setInfo(_T("CPngImage"), FALSE);
}

// test loading a .png into a svlPngImage multiple times
// this will not leak
// svlPngImage is essentially the same as Microsoft's CPngImage but the LoadFromBuffer() method unlocks and then frees the HGLOBAL
// Ideally we'd inherit from CPngImage, but LoadFromBuffer() isn't virtual so we can't replace it like that
//
// You can use svlPngImage as a drop in replacement for CPngImage. It works the identically but doesn't leak the memory CPngImage does.
// You can only allocate about 64K HGLOBALs before you can't allocate any more. To see the CPngImage leak set the count to 64K and choose one of the two CPngImage options

void CtestCPngImageDlg::OnBnClickedButtonTestSVLPng()
{
	DWORD	i, n;

	success = 0;
	fail = 0;

	setInfo(_T("svlPngImage"), TRUE);

	n = getCount();
	for(i = 0; i < n; i++)
	{
		UINT		id = IDB_BITMAP_PNG;
		svlPngImage image;
		int			ok;

		ok = image.Load(id, AfxGetInstanceHandle());
		handleSuccessFailure(ok, IDC_STATIC_STATUS_SVL_PNG, _T("PNG"));
	}

	setInfo(_T("svlPngImage"), FALSE);
}

